variables:
  MAVEN_CLI_OPTS: "-s .m2/settings.xml --batch-mode"
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository"
  CONTAINER: bmh-data
  GOLANG_VERSION: "1.23"

stages:
  - test
  - build
  - deploy

.checkShell:
  stage: test
  image: ${TOOLING_REGISTRY}/koalaman/shellcheck-alpine:stable
  script:
  - shellcheck $(find . -type f -exec grep -q '^#!/bin/bash' \{\} \; -print)
  tags:
  - kanod-docker

gocheck:
  stage: test
  image: "golang:${GOLANG_VERSION}"
  script:
  - make lint 
  - make build 
  tags:
  - kanod-docker

build:
  stage: build
  image: "golang:${GOLANG_VERSION}"
  artifacts:
    paths:
      - bin
  script:
    - make build
  tags:
    - kanod-docker
  only:
    - tags

container:
  stage: deploy
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - |
        if [ -n "${REGISTRY_MIRROR:-}" ]; then
          mirror_config="--skip-tls-verify-registry ${REGISTRY_MIRROR} --registry-mirror ${REGISTRY_MIRROR}"
        else
          mirror_config=''
        fi
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"${CI_REGISTRY}\":{\"auth\":\"$(printf "%s:%s" "${CI_REGISTRY_USER}" "${CI_REGISTRY_PASSWORD}" | base64 | tr -d '\n')\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor ${mirror_config} --insecure --skip-tls-verify --build-arg http_proxy --build-arg https_proxy --build-arg no_proxy --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/Dockerfile --destination "${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG}"
  tags:
    - kanod-docker
  rules:
    - if: $CI_COMMIT_TAG =~ /^v(?:\d+.){2}(?:\d+)$/

doc:
  image: python:3.9-alpine
  stage: deploy
  script:
  - apk add --no-cache make curl
  - pip3 install -U sphinx sphinx-jsonschema sphinxcontrib.asciinema sphinx_rtd_theme
  - (cd doc; make pre-build html)
  - mv doc/build/html public
  artifacts:
    paths:
    - public
  when: manual
  tags:
  - docker
